stages:
  - check
  - prepare
  - deploy
  - release

.only-tag: &only_tag
  only:
    refs:
      - tags
      - /^v\d+\.\d+\.\d+$/
    variables:
      - $PUB_CREDENTIALS
      - $CI_API_KEY

format:
  stage: check
  image: google/dart:latest
  only:
    - merge_requests
  tags:
    - docker
  script:
    - dartfmt . --set-exit-if-changed --fix -n

analyze:
  stage: check
  image: google/dart:latest
  only:
    - merge_requests
  tags:
    - docker
  script:
    - pub get
    - dartanalyzer . --fatal-infos --fatal-warnings

changelog:
  stage: prepare
  image: registry.git.pattle.im/pattle/util/release-manager:latest
  <<: *only_tag
  variables:
    GIT_STRATEGY: none
  tags:
    - docker
  script:
    - release-manager -action changelog
  artifacts:
    paths:
      - CHANGELOG.md
    expire_in: 1 week

publish:
  stage: deploy
  image: google/dart:latest
  <<: *only_tag
  tags:
    - docker
  dependencies:
    - changelog
  script:
    - mkdir -p ~/.pub-cache
    - echo "$PUB_CREDENTIALS" > ~/.pub-cache/credentials.json
    - 'echo -e "\nversion: ${CI_COMMIT_REF_NAME:1}" >> pubspec.yaml'
    - pub publish --force
  after_script:
    - rm ~/.pub-cache/credentials.json

release:
  stage: release
  image: registry.git.pattle.im/pattle/util/release-manager:latest
  <<: *only_tag
  variables:
    GIT_STRATEGY: none
  tags:
    - docker
  dependencies: []
  script:
    - release-manager -action release
